//#define DEBUG_OUTPUT

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

const int MAXN = 1024;
const int MAXDIVS = 256;
const int MAXPRIMES = 7;

int n, x;
int k, x_primes[MAXPRIMES], x_degs[MAXPRIMES];
int q, divs[MAXDIVS], masks[MAXDIVS];
int vis[MAXN][1 << MAXPRIMES], fr0[MAXN][1 << MAXPRIMES], fr1[MAXN][1 << MAXPRIMES];

void find_divisors(int i, int d)
{
    if (i == k) {
        if (d == 1) return;
        divs[q] = d;
        for (int j = 0; j < k; j++) {
            int ok = 1;
            int d1 = d;
            for (int sc = 0; sc < x_degs[j]; sc++) {
                if (d1 % x_primes[j]) {
                    ok = 0;
                    break;
                }
                d1 /= x_primes[j];
            }
            if (ok) masks[q] |= (1 << j);
        }
        q++;
        return;
    }

    int cur = 1;
    for (int j = 0; j <= x_degs[i]; j++) {
        find_divisors(i+1, d*cur);
        cur *= x_primes[i];
    }
}

int main()
{
    freopen("input.txt" ,"rt", stdin); freopen("output.txt", "wt", stdout);

    int i, j;
    cin >> n >> x;
    assert(2 <= n && n <= 1000);
    assert(2 <= x && x <= 1000000);

    int y = x;
    for (i = 2; i <= y; i++) {
        if (!(y % i)) {
            int deg = 0;
            while (!(y % i)) {
                y /= i;
                deg++;
            }
            x_primes[k] = i;
            x_degs[k] = deg;
            k++;
        }
    }

#ifdef DEBUG_OUTPUT
    cout << "n = " << n << endl;
    cout << "x = ";
    for (i = 0; i < k; i++) {
        if (i) cout << " * ";
        cout << x_primes[i] << "^" << x_degs[i];
    }
    cout << endl << endl;
#endif

    find_divisors(0, 1);

#ifdef DEBUG_OUTPUT
    cout << "x divisors (" << q << "): ";
    for (i = 0; i < q; i++) {
        if (i) cout << ", ";
        cout << divs[i] << "(" << masks[i] << ")";
    }
    cout << endl << endl;
#endif

    vis[0][0] = 1;
    for (i = 0; i < n; i++) {
        for (j = 0; j < (1 << k); j++) {
            if (!vis[i][j]) continue;
            for (int sc = 0; sc < q; sc++) {
                int i1 = i + divs[sc];
                int j1 = j | masks[sc];
                if (i1 <= n) {
                    vis[i1][j1] = 1;
                    fr0[i1][j1] = i;
                    fr1[i1][j1] = j;
                }
            }
        }
    }

    if (vis[n][(1 << k)-1]) {
        vector<int> ans;
        i = n, j = (1 << k) - 1;
        while (i) {
            ans.push_back(i - fr0[i][j]);
            int i1 = i, j1 = j;
            i = fr0[i1][j1];
            j = fr1[i1][j1];
        }
        reverse(ans.begin(), ans.end());

#ifdef DEBUG_OUTPUT
        cout << "n = ";
        for (i = 0; i < ans.size(); i++) {
            if (i) cout << " + ";
            cout << ans[i];
        }
        cout << endl << endl;
#endif

        int sum = 0;
        for (i = 0; i < ans.size(); i++) {
            for (j = 0; j < ans[i]-1; j++)
                cout << sum+j+2 << " ";
            cout << sum+1 << " ";
            sum += ans[i];
        }
        cout << endl;

        assert(sum == n);
    } else {
        cout << "-1" << endl;
    }

    fclose(stdin); fclose(stdout);
    return 0;
}
